#ifdef __ODFRC__

// general includes
#include "ActionDef.fh"
#include "ActionDefs.h"
#include "AdobeMenuPositions.h"
#include "BuildNumber.h"
#include "IControlViewDefs.h"
#include "InterfaceColorDefines.h"
#include "LocaleIndex.h"
#include "MenuDef.fh"
#include "ObjectModelTypes.fh"
#include "PanelList.fh"
#include "Schema.fh"
#include "StringTable.fh"
#include "Tips.fh"
#include "Widgets.fh"

// ID includes
#include "ActionID.h"
#include "CommandID.h"
#include "GenericID.h"
#include "NoteID.h" // for kNote*Boss
#include "PMLocaleIDs.h"
#include "PrintID.h"
#include "ShuksanID.h"
#include "SplineID.h"
#include "SysControlIDs.h"
#include "TablesID.h"
#include "TextID.h"
#include "TextEditorID.h" // for kTextSelectionBoss
#include "WidgetID.h"
#include "WorkspaceID.h"
#include "WritingModeID2.h" // for kGalley*Boss

#if kMajorVersionNumber >= 7
# include "PlugInModel_UIAttributes.h"
#endif

// project includes
#include "TextCountID.h"
#include "DTPTools.fh"

#define USE_INTEGRATED_ESELLER 1

#if kMajorVersionNumber >= 4

# if kMajorVersionNumber >= 7
resource PNGA(kTextCountLogoPictResourceID)				"./res/graphics/about.png"
resource PNGA(kTextCountIntroSlide01PictResourceID)		"./res/graphics/slide01u.png"
#  if WINDOWS
resource PNGA(kTextCountIntroSlide02PictResourceID)		"./res/graphics/slide02w.png"
resource PNGA(kTextCountIntroSlide03PictResourceID)		"./res/graphics/slide03w.png"
resource PNGA(kTextCountIntroSlide04PictResourceID)		"./res/graphics/slide04w.png"
resource PNGA(kTextCountIntroSlide05PictResourceID)		"./res/graphics/slide05w.png"
resource PNGA(kTextCountIntroSlide06PictResourceID)		"./res/graphics/slide06w.png"
#  else
resource PNGA(kTextCountIntroSlide02PictResourceID)		"./res/graphics/slide02m.png"
resource PNGA(kTextCountIntroSlide03PictResourceID)		"./res/graphics/slide03w.png" // FIXME: mac picture is wrong, we are using win version for now 
resource PNGA(kTextCountIntroSlide04PictResourceID)		"./res/graphics/slide04m.png"
resource PNGA(kTextCountIntroSlide05PictResourceID)		"./res/graphics/slide05m.png"
resource PNGA(kTextCountIntroSlide06PictResourceID)		"./res/graphics/slide06m.png"
#  endif
resource PNGA(kTextCountIntroSlide07PictResourceID)		"./res/graphics/slide07u.png"
# endif

resource PNGA(3021) "./res/graphics/oversetframes_bw.png"
resource PNGR(3021) "./res/graphics/oversetframes_color.png"

resource PNGA(3022) "./res/graphics/oversetpreflight_bw.png"
resource PNGR(3022) "./res/graphics/oversetpreflight_color.png"

resource PNGA(3031) "./res/graphics/enlargetexttofit_bw.png"
resource PNGR(3031) "./res/graphics/enlargetexttofit_color.png"

resource PNGA(3032) "./res/graphics/shrinktexttofit_bw.png"
resource PNGR(3032) "./res/graphics/shrinktexttofit_color.png"

resource PNGA(3040) "./res/graphics/createreport_bw.png"
resource PNGR(3040) "./res/graphics/createreport_color.png"

resource PNGA(3050) "./res/graphics/customizepanel_bw.png"
resource PNGR(3050) "./res/graphics/customizepanel_color.png"

#endif

resource DTPToolsProductData(1)
{
	{},

	"Text Count",
	kTextCountVersionString,
	"/textcount/",
	"tcin",
	kTextCountLogoPictResourceID,
	
	kTrue,
	kTrue,
	
	{
		kTextCountIntroSlide01TitleKey,
		kTextCountIntroSlide01TextKey,
		kTextCountIntroSlide01PictResourceID,

		kTextCountIntroSlide02TitleKey,
		kTextCountIntroSlide02TextKey,
		kTextCountIntroSlide02PictResourceID,
		
		kTextCountIntroSlide03TitleKey,
		kTextCountIntroSlide03TextKey,
		kTextCountIntroSlide03PictResourceID,

		kTextCountIntroSlide04TitleKey,
		kTextCountIntroSlide04TextKey,
		kTextCountIntroSlide04PictResourceID,

		kTextCountIntroSlide05TitleKey,
		kTextCountIntroSlide05TextKey,
		kTextCountIntroSlide05PictResourceID,

		kTextCountIntroSlide06TitleKey,
		kTextCountIntroSlide06TextKey,
		kTextCountIntroSlide06PictResourceID,

		kTextCountIntroSlide07TitleKey,
		kTextCountIntroSlide07TextKey,
		kTextCountIntroSlide07PictResourceID,
	},
	
	"\x07\x78\x68\x11\x0d\x0c\x0e\x11",						// DT-102-
	"\x0c\x7d\x7f\x68\x0e\x0d\x09\x0d\x0a\x0f\x0a\x0d\x0c",	// ACT215163610
#if WINDOWS
	"\x0c\x79\x6f\x05\x09\x0e\x0d\x0a\x0a\x0f\x04\x0a\x0c",	// ES9521663860 WIN
#else
	"\x0c\x79\x6f\x08\x0e\x09\x0e\x09\x08\x0a\x0d\x08\x09",	// ES4252546145 MAC
#endif
};

resource DTPToolsSerialNumberLockData(1)
{{
	// 10374423450677487500 - GR
	"\x14\x0d\x0c\x0f\x0b\x08\x08\x0e\x0f\x08\x09\x0c\x0a\x0b\x0b\x08\x04\x0b\x09\x0c\x0c",
	
	// 11310417272724641225 - Meredith
	"\x14\x0d\x0d\x0f\x0d\x0c\x08\x0d\x0b\x0e\x0b\x0e\x0b\x0e\x08\x0a\x08\x0d\x0e\x0e\x09",

	// 10374035291903208834 - GR CS3 Debug
	"\x14\x0d\x0c\x0f\x0b\x08\x0c\x0f\x09\x0e\x05\x0d\x05\x0c\x0f\x0e\x0c\x04\x04\x0f\x08"
}};

resource DTPToolsPackageData(1)
{{
	1424134817,	// dtp tools cloud, encoded
}};

/*
resource DTPToolsExtendedTryoutData(1)
{
	// 11310417272724641225 - Meredith
	"\x14\x0d\x0d\x0f\x0d\x0c\x08\x0d\x0b\x0e\x0b\x0e\x0b\x0e\x08\x0a\x08\x0d\x0e\x0e\x09",
	
	// 30 days
	1416407387
};

*/
// plugin version definition
resource PluginVersion (1)
{
	kTargetVersion,
	kTextCountPluginID,
	
	kTextCountPluginMajorVersionNumber, kTextCountPluginMinorVersionNumber,
	kMajorVersionNumber, kMinorVersionNumber,
/*
#if kMajorVersionNumber >= 5
	1, 2,
#else
*/
	kDragontailMajorFormatNumber, kDragontailInitialMinorFormatNumber,
	// kSDKDef_30_PersistMajorVersionNumber, kSDKDef_30_PersistMinorVersionNumber,
/*
#endif
*/

	{ kInDesignProduct, kInCopyProduct },
	{ kWildFS },

#if kMajorVersionNumber >= 7
	kUIPlugIn,
#endif

	kTextCountFullVersionString
};

resource IgnoreTags(1)
{
	kImplementationIDSpace,
	{
		kTextCountOversetTagImpl,
		kTextCountPrefsImpl,
		kTextCountProfileListImpl,
		kTextCountCreateReportDialogControllerImpl,
	}
};

// ------------------------------------------------------------------------
// plugin dependency
// ------------------------------------------------------------------------

resource PluginDependency(1)
{
	kWildFS,
	{
		// DTP Tools plugin
		kDTPToolsPluginID,
		kDTPToolsPluginName,
		kDTPToolsPluginMajorVersionNumber,
		kDTPToolsPluginMinorVersionNumber,
	},
};


// boss class definition
resource ClassDescriptionTable(1)
{{{

    // ------------------------------------------------------------------------
    // addins
    // ------------------------------------------------------------------------

	AddIn
	{
		kSessionBoss,
		kInvalidClass,
		{
			IDD_ITEXTCOUNTLICENSESTATE, kIntDataImpl,
		}
	},

	AddIn
	{
		kWorkspaceBoss,
		kInvalidClass,
		{
			IID_ITEXTCOUNTCOMMANDINTERCEPTOR, kTextCountCommandInterceptorImpl,
			IID_ITEXTCOUNTPREFS, kTextCountPrefsImpl,
			IID_ITEXTCOUNTPROFILELIST, kTextCountProfileListImpl,
		}
	},

	AddIn
	{
		kDocWorkspaceBoss,
		kInvalidClass,
		{
			IID_ITEXTCOUNTPREFS, kTextCountPrefsImpl,
			IID_ITEXTCOUNTPROFILELIST, kTextCountProfileListImpl,
		}
	},


	// ------------------------------------------------------------------------
    // suite
	// ------------------------------------------------------------------------

	AddIn
	{
	    kIntegratorSuiteBoss,
	    kInvalidClass,
	    {
	        IID_ITEXTCOUNTSUITE, kTextCountASBImpl,
	    }
	},

	AddIn
	{
		kTextSuiteBoss,
		kInvalidClass,
		{
			IID_ITEXTCOUNTSUITE, kTextCountTextCSBImpl,
		}
	},

	AddIn
	{
		kGalleyTextSuiteBoss,
		kInvalidClass,
		{
			IID_ITEXTCOUNTSUITE, kTextCountTextCSBImpl,
		}
	},

	AddIn
	{
		kNoteTextSuiteBoss,
		kInvalidClass,
		{
			IID_ITEXTCOUNTSUITE, kTextCountTextCSBImpl,
		}
	},

	AddIn
	{
		kLayoutSuiteBoss,
		kInvalidClass,
		{
			IID_ITEXTCOUNTSUITE, kTextCountLayoutCSBImpl,
		}
	},
	
	AddIn
	{
		kTableSuiteBoss,
		kInvalidClass,
		{
			IID_ITEXTCOUNTSUITE, kTextCountTableCSBImpl,
		}
	},
	

    // ------------------------------------------------------------------------
    // stats cache
    // ------------------------------------------------------------------------
    
	AddIn
	{
		kSplineItemBoss,
		kInvalidClass,
		{
            IID_ITEXTCOUNTSTATS, kTextCountTextFrameStatsImpl,
		}
	},


	AddIn
	{
	    kTextStoryBoss,
		kInvalidClass,
		{
            IID_ITEXTCOUNTSTATS, kTextCountStoryStatsImpl,
        }	    
	},


    // ------------------------------------------------------------------------
    // overset frame identifier
    // ------------------------------------------------------------------------

	AddIn
	{
		kMultiColumnItemBoss,
		kInvalidClass,
		{
            IID_ITEXTCOUNTOVERSETTAG, kTextCountOversetTagImpl,
			IID_ITEXTCOUNTDISALLOWRECOMPOSEFLAG, kFalseInitBoolDataImpl,
		}
	},


    // ------------------------------------------------------------------------
    // document observer and overset list
    // ------------------------------------------------------------------------
    
	AddIn
	{
		kDocBoss,
		kInvalidClass,
		{
            IID_ITEXTCOUNTDOCUMENTOBSERVER, kTextCountDocumentObserverImpl,
            IID_ITEXTCOUNTOVERSETLIST, kTextCountOversetListImpl,
			IID_ITEXTCOUNTREPORT, kTextCountReportImpl,
        }	    
	},


	Class
    {
        kTextCountConversionProviderBoss,
        kInvalidClass,
        {
            IID_ICONVERSIONPROVIDER, kTextCountConversionProviderImpl,
            IID_IK2SERVICEPROVIDER, kConversionServiceImpl,
        }	
    }
	
	
    // ------------------------------------------------------------------------
    // dialogs
    // ------------------------------------------------------------------------
    
	Class
	{
		kTextCountCustomizePanelDialogBoss,
		kDialogBoss,
		{
			IID_IDIALOGCONTROLLER, kTextCountCustomizePanelDialogControllerImpl,
			IID_IOBSERVER, kTextCountCustomizePanelDialogObserverImpl,
		}
	},
	
	Class
	{
		kTextCountPrefsDialogBoss,
		kPrimaryResourcePanelWidgetBoss,
		{
			IID_IDIALOGCONTROLLER, kTextCountPrefsDialogControllerImpl,
			IID_IOBSERVER, kTextCountPrefsDialogObserverImpl,
			IID_IPANELCREATOR, kTextCountPrefsPanelCreatorImpl,
			IID_IK2SERVICEPROVIDER, kDialogPanelServiceImpl,
		}
	},

	Class
	{
		kTextCountCreateReportDialogBoss,
		kDialogBoss,
		{
			IID_IDIALOGCONTROLLER, kTextCountCreateReportDialogControllerImpl,
			IID_IOBSERVER, kTextCountCreateReportDialogObserverImpl,
			IID_ITEXTCOUNTREPORTDATA, kTextCountReportDataImpl,
			IID_IBOOLDATA, kBoolDataImpl,
		}
	},

	Class
	{
		kTextCountProfileDialogBoss,
		kDialogBoss,
		{
			IID_IDIALOGCONTROLLER, kTextCountProfileDialogControllerImpl,
			IID_IOBSERVER, kTextCountProfileDialogObserverImpl,
			IID_ISTRINGDATA, kStringDataImpl,
			IID_IBOOLDATA, kBoolDataImpl,
			IID_ITEXTCOUNTPROFILELIST, kTextCountNonPersistProfileListImpl,
			IID_IINTDATA, kIntDataImpl,
		}
	},


    // ------------------------------------------------------------------------
    // commands
    // ------------------------------------------------------------------------
    
	Class
	{
		kTextCountStartupCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountStartupCmdImpl,
		}		
	},

	Class
	{
		kTextCountCreateOversetFrameCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountCreateOversetFrameCmdImpl,
		}		
	},

	Class
	{
		kTextCountUpdateOversetFrameCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountUpdateOversetFrameCmdImpl,
		}		
	},

	Class
	{
		kTextCountDeleteOversetFrameCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountDeleteOversetFrameCmdImpl,
		}		
	},
	
	Class
	{
		kTextCountSetShowOversetFramesCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountSetShowOversetFramesCmdImpl,
			IID_IBOOLDATA, kBoolDataImpl,
		}		
	},
	
	Class
	{
		kTextCountSetEnablePreflightCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountSetEnablePreflightCmdImpl,
			IID_IBOOLDATA, kBoolDataImpl,
		}		
	},
	
	Class
	{
		kTextCountSetPrefsCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountSetPrefsCmdImpl,
			IID_ITEXTCOUNTPROFILESDATA, kTextCountProfilesDataImpl,
		}		
	},
	
	Class
	{
		kTextCountSetActiveProfileCmdBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountSetActiveProfileCmdImpl,
			IID_IINTDATA, kIntDataImpl,
		}
	},
	
	Class
	{
		kTextCountGlobalUpdateBoss,
		kInvalidClass,
		{
			IID_ICOMMAND, kTextCountGlobalUpdateCmdImpl,
		}
	},
	
	
    // ------------------------------------------------------------------------
    // command interceptor
    // ------------------------------------------------------------------------

	Class
	{
		kTextCountCommandInterceptorBoss,
		kInvalidClass,
		{
			IID_ICOMMANDINTERCEPTOR, kTextCountCommandInterceptorImpl,
		}
	};


    // ------------------------------------------------------------------------
    // service providers
    // ------------------------------------------------------------------------

	Class
	{
		kTextCountResponderBoss,
		kInvalidClass,
		{
			IID_IK2SERVICEPROVIDER,		kTextCountServiceProviderImpl,
			IID_IPRINTSETUPPROVIDER,	kTextCountPrintSetupProviderImpl,
#if kMajorVersionNumber >= 7
			IID_ISTARTUPSHUTDOWN,		kTextCountStartupShutdownProviderImpl,
#else
			IID_IAPPSTARTUPSHUTDOWN,	kTextCountStartupShutdownProviderImpl,
#endif
			IID_IRESPONDER,				kTextCountResponderImpl,
		}
	};


    // ------------------------------------------------------------------------
    // action component
    // ------------------------------------------------------------------------

	Class
	{
		kTextCountActionComponentBoss,
		kInvalidClass,
		{
			IID_IACTIONCOMPONENT,   kTextCountActionComponentImpl,
			IID_IDYNAMICMENU,       kTextCountPanelDynamicMenuImpl,
			IID_IACTIONIDTOUIDDATA, kActionIDToUIDDataImpl,
			IID_IPMPERSIST,         kPMPersistImpl
		}
	},


    // ------------------------------------------------------------------------
    // panel
    // ------------------------------------------------------------------------

	Class
	{
		kTextCountPanelWidgetBoss,
		kPalettePanelWidgetBoss,
		{
		//	IID_ICONTROLVIEW, kTextCountPanelControlViewImpl,
		
			IID_ICONTROLVIEWOBSERVERS, kCControlViewObserversImpl,
			IID_IPANELMENUDATA, kCPanelMenuDataImpl,

			IID_ITEXTCOUNTWIDGETOBSERVER, kTextCountWidgetObserverImpl,
			IID_ITEXTCOUNTSELECTIONOBSERVER, kTextCountSelectionObserverImpl,
			IID_ITEXTCOUNTPANELLAYOUT, kTextCountPanelLayoutImpl,
		}
	},
}}};


// implementation definition
resource FactoryList (1)
{
	kImplementationIDSpace,
	{
		#include "TextCountFactoryList.h"
	}
};

// menu definition
resource MenuDef (1)
{{
    // panel popup menu
	kInvalidActionID,						kTextCountProfileMenuPath ":",	10.0,	kFalse,
	
	// profile placeholder
	kTextCountProfilePlaceholderActionID,	kTextCountProfileMenuPath,		1.0,	kTrue,

    // text count preference
	kTextCountPrefsActionID,				"Main:&Edit:Preferences",		1700.0,	kFalse,
}};

// action definition
resource ActionDef (1)
{{ 
	// profiles
	kTextCountActionComponentBoss, kTextCountProfileActionID, kTextCountProfileMenuItemKey,
	kOtherActionArea, kNormalAction, kDisableIfLowMem, kInvalidInterfaceID, kFalse,

	// profile placeholder
	kTextCountActionComponentBoss, kTextCountProfilePlaceholderActionID, kTextCountProfilePlaceholderMenuItemKey,
	kOtherActionArea, kNormalAction, kDisableIfLowMem, kInvalidInterfaceID, kFalse,

	// preferences
	kTextCountActionComponentBoss, kTextCountPrefsActionID, kTextCountPrefsMenuItemKey,
	kOtherActionArea, kNormalAction, kDisableIfLowMem, kInvalidInterfaceID, kFalse,
}};

resource PanelList (1)
{
#if kMajorVersionNumber < 5

	1,		// Palette number for default placement
	initiallyVisible,				// Initial visible flag (initiallyHidden/initiallyVisible)
	{
		// 1st panel in the list
		1108,		    // Resource ID for this panel (use SDK default rsrc ID)
		kTextCountPluginID,	            // ID of plug-in that owns this panel
		1,    // Z-order in palette
		kTextCountPanelWidgetActionID,	// Action ID to show/hide the panel
		kTextCountPanelTitleKey,        // Shows up in the Window list.
		"",							    // Alternate menu path of the form "Main:Foo" if you want your palette menu item in a second place
		0.0,						    // Alternate Menu position Alternate Menu position for determining menu order
	}
#else

	{
		// 1st panel in the list
		1108,		// Resource ID for this panel (use SDK default rsrc ID)
		kTextCountPluginID,			// ID of plug-in that owns this panel
# if kMajorVersionNumber == 5
		notResizable,						// is this panel resizable?
# else
		kNotResizable,
# endif
		kTextCountPanelWidgetActionID,	// Action ID to show/hide the panel
		kTextCountPanelTitleKey,		// Shows up in the Window list.
		"",							// Alternate menu path of the form "Main:Foo" if you want your palette menu item in a second place
		0.0,						// Alternate Menu position Alternate Menu position for determining menu order
		3022, kTextCountPluginID,						// Rsrc ID, Plugin ID for a PNG icon resource to use for this palette
		c_Panel
	}	

#endif

};

resource TipTable(33)
{{
    kTextCountRangeSelectionWidgetID,       kTextCountRangeSelectionTipKey,
    kTextCountOversetFramesWidgetID,        kTextCountOversetFramesTipKey,
    kTextCountPreflightWidgetID,	        kTextCountPreflightTipKey,
    kTextCountFitTextToFrameWidgetID,	    kTextCountFitTextToFrameTipKey,
    kTextCountCreateReportWidgetID,	        kTextCountCreateReportTipKey,
    kTextCountCustomizePanelWidgetID,	    kTextCountCustomizePanelTipKey,
    kTextCountCntTitleWidgetID,             kTextCountCntTitleTipKey,
    kTextCountOvrTitleWidgetID,             kTextCountOvrTitleTipKey,
    kTextCountEstTitleWidgetID,             kTextCountEstTitleTipKey,
    kTextCountChAllTtlWidgetID,             kTextCountChAllTtlTipKey,
    kTextCountChNSpTtlWidgetID,             kTextCountChNSpTtlTipKey,
    kTextCountWordsTtlWidgetID,             kTextCountWordsTtlTipKey,
    kTextCountLinesTtlWidgetID,             kTextCountLinesTtlTipKey,
    kTextCountParasTtlWidgetID,             kTextCountParasTtlTipKey,
    kTextCountManLnTtlWidgetID,             kTextCountManLnTtlTipKey,
    kTextCountManPgTtlWidgetID,             kTextCountManPgTtlTipKey,
    kTextCountPriceTtlWidgetID,             kTextCountPriceTtlTipKey,
    kTextCountInfoLineWidgetID,             kTextCountInfoLineTipKey,
}}


// English strings
#include "TextCount_enUS.fr"

// German strings
//#include "TextCount_deDE.fr"

// English dialogs
#include "CustomizePanelDialog_enUS.fr"
#include "PrefsDialog_enUS.fr"
#include "CreateReportDialog_enUS.fr"
#include "ProfileDialog_enUS.fr"

// English panels
#include "Panel_enUS.fr"


#endif // __ODFRC__
